//+------------------------------------------------------------------+
//|                                                    RangerADX.mq4 |
//|                          Copyright  2009, Doshur Software Corp. |
//|                                            http://www.doshur.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Doshur Software Corp."
#property link      "http://www.doshur.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 White

extern int First = 7;
extern int Second = 14;

//---- buffers
double TSI[];
double Dif[];

double Pos[];
double Neg[];

double P_Buffer[];
double N_Buffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(6);

   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, TSI);

   SetIndexBuffer(1, Dif);
   SetIndexBuffer(2, Pos);
   SetIndexBuffer(3, Neg);
   SetIndexBuffer(4, P_Buffer);
   SetIndexBuffer(5, N_Buffer);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit, i;
   int counted_bars = IndicatorCounted();

   double O, C, H, L, CC;
   double Bull, Bear;

   limit = Bars - counted_bars;
//----
   for(i = 0; i <= limit; i++)
   {
      O = Open[i];
      C = Close[i];
      H = High[i];
      L = Low[i];

      CC = C - Close[i + 1];

      if(O >= C)
      {
         Bear = (H - L);
         Bull = (H - O) + (C - L);

         if(CC > 0)
            Bull += CC;
         else
            Bear -= CC;

         P_Buffer[i] = Bull;
         N_Buffer[i] = Bear;
      }

      if(C > 0)
      {
         Bull = (H - L);
         Bear = (O - L) + (H - C);

         if(CC > 0)
            Bull += CC;
         else
            Bear -= CC;

         P_Buffer[i] = Bull;
         N_Buffer[i] = Bear;
      }
   }

   for(i = 0; i <= limit; i++)
   {
      Pos[i] = iMAOnArray(P_Buffer, 0, First, 0, MODE_EMA, i);
      Neg[i] = iMAOnArray(N_Buffer, 0, First, 0, MODE_EMA, i);

      Dif[i] = Pos[i] - Neg[i];
   }

   for(i = 0; i <= limit; i++)
   {
      TSI[i] = iMAOnArray(Dif, 0, Second, 0, MODE_EMA, i);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+